"""
@author: Christian Reinhold and Henrik Wagner elenia@TUBS

The mosaik-car component models the mobility and charging behavior of EV. 
The EV's electricity demand is derived from profiles generated by the open-source tool emopby.
The model calculates its SoC in every step, based on the cars consumption and possible charging
power derived from mosaik-cs (charging station).

"""

# import packages
import pickle, os, gzip
from datetime import *

class car:
    """Models an electriv vehicle and its change of SoC depending on driving and charging.
    """
    # static properties
    type = 'car'                    # model type [-]

    # emobpy-file
    file_emobpy = 'data/emobpy_example.pickle' # is overwritten by model_data.json
    emobpy = None                   # data emobpy

    # emobpy-pickle parameters
    soc_init = 0.5                      # Initial SOC [-]
    E_bat_rated = 10000                 # Capacity [Wh]
    P_rated_discharge_max = 8000        # Rated discharging active power [W]
    P_rated_charge_max = 11000          # Rated charging active power [W]
    eff_discharge = 0.95                # efficiency discharge [-]
    eff_charge = 0.9                    # efficiency charge [-]
    start_time = "2020-01-01 00:00:00"  # default start time to be overwritten by pickle
    
    # exchange variables with CS for 1 min pickle
    ONE_MIN_PICKLE = False 
    NEXT_STEP_STANDING_MINUTES = False
    NEXT_STEP_MINUTES = False

    # sim properties
    delta = 60                          # Time-Delta [s]
    STANDING_TIME_END = -1              # End of EV charging prognosis

    # dynamic output properties
    appearance = None                   # Identifier if car at station [-]
    P_CHARGE_MAX = None                 # Maximal Charging Power [W]
    P_DISCHARGE_MAX = None              # Maximal Discharging Power [W]
    E_BAT_MAX = None                    # Maximal Charging Level [Wh]
    E_BAT = None                        # Actual charging level [Wh]
    SOC = None                          # Current SOC - State of Charge [-]
    STANDING_TIME = None                # Current standing time if appearence=1 [s]
    BEV_consumption_period = None       # Electricity consumption of EV in next period not being home, 
                                        # starting right after STANDING_TIME_END
    SIGNAL_PROGNOSIS_EV_CS = None       # Signal to request new forecast period based on BEV_consumption_period [-]
    
    # dynamic input properties
    P_BAT = None                        # Charging Power

    # result properties
    results = ['appearance', 'P_CHARGE_MAX', 'P_DISCHARGE_MAX', 'E_BAT_MAX', 'E_BAT']

    # init of values
    def __init__(self, init_vals):
        """Initializing mosaik-car model

        Args:
            init_vals (dict): Initial values of car instance. Read from model_data_car_cs.json
        """
        
        # assign init values
        for i, (key, value) in enumerate(init_vals.items()):
            setattr(self, key, value)

        # init emobpy-pickle file
        self.load_pickle_data()

        # assign car properties & pickle presets
        if self.emobpy is not None:
            self.E_bat_rated = self.emobpy["battery_capacity"]*10e2
            self.SOC = self.emobpy["soc_init"]
            self.start_time = datetime.strftime(datetime.strptime(self.emobpy["refdate"], '%d/%m/%Y'), '%Y-%m-%d %H:%M:%S') #activate if emobpy-pickle should set the start_time
            self.car_profile_name = self.emobpy["name"] #name of car model is not separately saved in _avai.pickle 
            self.pickle_refdate = datetime.strptime(self.emobpy["refdate"], '%d/%m/%Y')
            self.pickle_end = self.emobpy["totalrows"] # 35040
            self.pickle_timestep = self.emobpy["t"]
            self.E_BAT = self.SOC*self.E_bat_rated
            self.E_BAT_MAX = self.E_bat_rated

        # check start_time of emobpy-pickle     
        self.check_pickle_data()
    
    # load emobpy-pickle file
    def load_pickle_data(self):
        """Checking path and loading the pickle data for the corresponding mosaik-car model

        Raises:
            ImportError: Incorrect path for emobpy pickle or file is corrupted.
        """
       
        # check pickle path and open
        if os.path.exists(self.file_emobpy):
            pickle_file_path = self.file_emobpy
            pickle_off = gzip.open(pickle_file_path, "rb")
            self.emobpy = pickle.load(pickle_off)
            #self.emobpy = pd.read_pickle(pickle_off)
            pickle_off.close()
        else:
            # set emobpy data to none
            self.emobpy = None
            raise ImportError("emobpy-pickle file not loaded! Check path or if file is corrupted")
    
    # check data of emobpy-pickle file
    def check_pickle_data(self):
        """Checks if the simulation start date is within pickle file and reads-in mobility profile.

        Raises:
            ValueError: Start Date is not in pickle file.
        """
        
        # Check start date
        self.start_time_formatted = datetime.strptime(self.start_time,"%Y-%m-%d %H:%M:%S")
        if self.start_time_formatted < self.pickle_refdate:
            raise ValueError('Start date "%s" not in emobpy-pickle.' %
                             self.start_time.format(self.date_format))
        # Determine initial_pos in emobpy-pickle
        self.initial_pos = (self.start_time_formatted.hour*60 + self.start_time_formatted.minute)/60
        day_of_year = self.start_time_formatted.timetuple().tm_yday
        self.initial_pos +=(day_of_year-1)*24 

        # Read availability profile
        self.profile = self.emobpy["profile"]

        # Read initial SOC
        soc_init = self.profile[self.profile["hh"]==self.initial_pos]["soc"]
        self.SOC = soc_init

    # perform simulation step
    def step(self, time):
        """Calculate car parameters for current simulation step.

        Args:
            time (int): Current simulation time

        Raises:
            IndexError: End of emobpy-pickle file reached.
            ValueError: Set step size does not match with emobpy-pickle
        """

        # calculating current step in time format hh
        step = (time/(60*60))+self.initial_pos
        self.TIME=time

        # reset prognosis_signal
        self.SIGNAL_PROGNOSIS_EV_CS = 0

        # check if end of emobpy pickle file is reached
        if step >= (self.pickle_end*self.pickle_timestep):
            raise IndexError('End of emobpy-pickle file reached.')  
        
        # reason: as long as simulation time of whole co-simulation is 
        # >1min it is necessary to summarize all 1 min pickle values in the time vector given by simulation
        if  self.emobpy["t"] == 60/3600:
        
            # execute step for one minute pickle-file
            self._step_ONE_MIN_pickle(step)
                
        # calculation of consumption and standing time 15 min pickle file
        else:
            
            # determine position of the current step
            pos = self.profile.hh == step

            # check if current step is within emobyp-pickle
            # TODO: Auslagern in check_pickle_data, dann auch in _step_ONE_MIN_pickle entfernen
            if any(pos) == False:
                raise ValueError('Current step size does not fit emobbpy-pickle')

            # read current consumption and save it
            self.consumption = float(self.profile.loc[pos,'consumption'].values)
            
            # check if end of standing_time at home is already known to reduce simulating time
            if (step*3600) > self.STANDING_TIME_END or self.STANDING_TIME_END == -1:

                # check if EV is at home and therefore ready to be charged
                if self.profile.loc[pos,'charging_point'].values == 'home':
                    
                    # setting signal (appearance) that EV is home True (=1)
                    self.appearance = 1

                    # Calculate next STANDING_TIME period for EV
                    self.calc_STANDING_TIME(step)

                    # Calculate BEV_consumption_period
                    self.calc_BEV_consumption_period()
                    
                # car is not home in current step  
                else:
                    # setting signal that EV is home False (=0)
                    self.appearance = 0
                     
    # calculate average power for discharge of battery
        if self.consumption >0:
            # pickle length (1min)
            if self.ONE_MIN_PICKLE == True:
                    self.P_BAT = -self.consumption*1000/(self.delta/3600) + self.P_BAT
            # default pickle length (15min) 
            else: 
                self.P_BAT = -self.consumption*1000/(self.delta/3600)

        # calculate new charging level        
        if self.P_BAT is not None:
            if self.P_BAT >=0: 
                self.E_BAT = self.E_BAT + self.P_BAT*self.delta/3600*self.eff_charge
            elif self.P_BAT < 0:  
                self.E_BAT = self.E_BAT + self.P_BAT*self.delta/3600*self.eff_discharge
            
        #TODO: Fix cs strategies and then check if E_BAT<0 still appears
        if self.E_BAT<0:
            self.E_BAT = 0
            #print("Problem with EBAT. Check Car.py. Line 316")
        
        # compute soc
        self.SOC = min(self.E_BAT/self.E_bat_rated,1)

        # calculate maximum charging/discharging power of EV
        self.P_CHARGE_MAX = min((self.E_bat_rated - self.E_BAT)/self.eff_charge/(self.delta/3600), self.P_rated_charge_max)
        self.P_DISCHARGE_MAX = 0

    def calc_STANDING_TIME(self, step):
        """Calculates the STANDING_TIME describing the time period when the EV is home
        and ready to be charged until it leaves for the next trip.

        Args:
            step (float): Current simulation step converted in h for emobpy-profile
        """
        # Set start of STANDING_TIME
        self.STANDING_TIME_START = step*3600 #float(3600*self.profile.loc[pos,'hh'].values)                    
        self.standing_time_search = step
        iteration_end = False
        # set iterations to current simulation time (!= step)
        self.iterations = self.TIME
        while iteration_end != True:
            # check if search for STANDING_TIME exceeds end of simulation
            if self.iterations <= self.END:
                self.iterations += self.delta
                self.standing_time_search += (self.delta/3600)
                pos = self.profile.hh == self.standing_time_search
                if self.profile.loc[pos,'charging_point'].values != 'home':
                    iteration_end = True
                    pos_ende = self.profile.hh == (self.standing_time_search-(self.delta/3600))
                    self.STANDING_TIME_END = float(3600*self.profile.loc[pos_ende,'hh'].values)
            else:
                iteration_end = True
                self.STANDING_TIME_END = self.STANDING_TIME_START + (self.END - self.TIME)
        # calculate STANDING_TIME for current period with appearance of EV at home
        self.STANDING_TIME = self.STANDING_TIME_END-self.STANDING_TIME_START 

    def calc_BEV_consumption_period(self):
        """Calculates BEV_consumption_period defining the 
        electricity consumption of the BEV in the next period while not being home
        """

        # Set signal for prognosis TRUE/1 as a new period of STANDING_TIME is initialized
        self.SIGNAL_PROGNOSIS_EV_CS = 1
        
        # iterator
        iteration_end = False
        
        # reset BEV_consumption for current period
        self.BEV_consumption_period = 0
        
        while iteration_end != True:
            if self.iterations <= self.END:
                pos = self.profile.hh == self.standing_time_search

                # check if the EV comes home ending the current period of BEV consumption
                if self.profile.loc[pos,'charging_point'].values == 'home':
                    iteration_end = True
                    # TODO: check if this can be used to optimize simulation time
                    self.STANDING_TIME_START_new = float(3600*self.profile.loc[pos,'hh'].values)
                
                # checking if EV is currently driving and therefore consuming energy
                elif self.profile.loc[pos,'state'].values == 'driving':
                    # save energy consumption [Wh]
                    self.BEV_consumption_period += float(self.profile.loc[pos,'consumption'].values)*1000
                
                # increasing standing_time_search
                self.standing_time_search += (self.delta/3600)

            else:
                iteration_end = True

    def _step_ONE_MIN_pickle(self,step):
        # setting variable for displaying 1 min pickle
        self.ONE_MIN_PICKLE = True

        # initialisation of driving time loop; loop runs in current time step
        if step == False:
            self.driving_time_start = 0
            self.driving_time_end = 1
        else:
            self.driving_time_start = self.next_step_minute_start
            self.driving_time_end = self.next_step_minute_end
        
        # reset of consumption
        self.consumption = 0

        #  calculation of consumption for given time vector    
        for i in range (self.driving_time_start,self.driving_time_end): 
            
            pos = self.profile.hh == self.emobpy["t"] * i
            
            # check if current step is within emobyp-pickle
            if any(pos) == False: 
                raise ValueError('Current step size does not fit emobbpy-pickle')

            # reading and caching current consumption 
            self.consumption += float(self.profile.loc[pos,'consumption'].values)

        
        # initialisation of standing time loop; loop runs in next step
        if step == False:
            self.next_step_minute_start = 0
            self.next_step_minute_end = 1
            # iteration variable for standing time start
            self.iter_start = 0 
            # iteration variable for standing time end
            self.iter_end = 1 
        else:
            self.iter_start +=1
            self.iter_end +=1

        # reset standing minutes for next period
        self.NEXT_STEP_STANDING_MINUTES = 0
        
        # calculation starting time for next period 
        self.next_step_minute_start = int(self.delta * self.emobpy["t"] * self.iter_start)

        # calculation ending time for next period
        self.next_step_minute_end = int(self.delta * self.emobpy["t"] * self.iter_end) 

        # calculation of total possible standing time for next step
        self.NEXT_STEP_MINUTES = self.next_step_minute_end - self.next_step_minute_start

        # calculation of standing time and setting appearance for next period
        for i in range (self.next_step_minute_start,self.next_step_minute_end):

            # check current position
            pos = self.profile.hh == self.emobpy["t"] * i
            # check if current step is within emobyp-pickle
            if any(pos) == False: 
                raise ValueError('Current step size does not fit emobbpy-pickle')
            #summation of status "home" of EV for setting of appearance; 'charging_point' (e.g. public) also possible
            if self.profile.loc[pos,'state'].values == 'home':
                self.NEXT_STEP_STANDING_MINUTES +=1 
                #caching standing time search variable for calcutlation of available night time css
                if self.NEXT_STEP_STANDING_MINUTES == 1:
                    standing_time_search = self.emobpy["t"] * i
                    self.STANDING_TIME_START = float(3600*standing_time_search)        
            elif self.NEXT_STEP_STANDING_MINUTES == 0:
                    standing_time_search = 0
                
        #check if end of standing_time at home is already known to reduce simulating time
        if (standing_time_search*3600) > self.STANDING_TIME_END or self.STANDING_TIME_END == -1:
        # calculate standing_time: check if EV is at home and therefore ready to be charged
            iteration_end = False
            i = (standing_time_search * 60) - 1
            iterations = self.TIME
            while iteration_end != True:
                if iterations <= self.END:
                    i+=1
                    iterations += self.delta/15 
                    standing_time_search = self.emobpy["t"]*i 
                    pos = self.profile.hh == standing_time_search
                    #NOTE: with proper 1-min pickle-files it should be 'charging_point' instead of 'state'
                    if self.profile.loc[pos,'state'].values != 'home':
                        iteration_end = True
                        i -=1
                        pos_ende = self.profile.hh == (self.emobpy["t"]*i)
                        self.STANDING_TIME_END = float(3600*self.profile.loc[pos_ende,'hh'].values)     
                else:
                    iteration_end = True
                    self.STANDING_TIME_END = self.END
            # calculate STANDING_TIME for current period with appearance of EV at home
            self.STANDING_TIME= self.STANDING_TIME_END-self.STANDING_TIME_START 

        # setting value of appearance in dependence of Standing Time
        if self.NEXT_STEP_STANDING_MINUTES > 0:
            self.appearance = 1
        else:
            self.appearance = 0

class Simulator(object):
    """Simulator class for mosaik-car model
    Creates multiple instances and saves the results in an accesible list

    Args:
        object (class): Generic class
    """

    def __init__(self):
        """Constructor
        """

        # init data elments
        self.models = []
        self.results = []

    # create model instances
    def add_model(self, init_vals):
        """Creates instances of the car model

        Args:
            init_vals (dict): Dictionary with the initial values of the car model,
            needs to contain the path

        Returns:
            carmodel: car model object
        """

        # create model with init values
        model = car(init_vals)

        # add model to model storage
        self.models.append(model)

        # add list for simulation data
        self.results.append([])

        # return model
        return model

    # perform simulation step of all models
    def step(self, time):
        """Performs a simulation step

        Args:
            time (int): Current simulation time
        """
        
        # Enumaration over all models in simulator
        for i, model in enumerate(self.models):
            # perform simulation step
            model.step(time)

            # collect data of model and storage local
            for j, signal in enumerate(model.results):
                self.results[i].append(getattr(model,signal))